.TH TKBIFF 1 "4 February 1995"
.SH NAME
tkbiff \- Tk-based mail notifier
.SH SYNOPSIS
.B tkbiff
[
.I args
]
.SH INTRODUCTION
tkbiff is a Tk-based mail notifier.  tkbiff is similar to other biffs
except that tkbiff can invoke any command or operation rather than
being restricted to, for example, playing a sound clip.  In other
words, tkbiff is very flexible.  If you want to change the appearance
of tkbiff or the way it behaves, it is easy to do.
.PP
tkbiff comes with a very pleasant default configuration.  The default
configuration is aimed at three things:
.TP
.B Speed
tkbiff lets you browse mail with a single mouse click.
This is particularly convenient if you normally use \fIheavy-duty\fR
mail readers such as emacs-vm which, although flexible, can be slow
and in states where it is inconvenient to rearrange window
configurations just to peek to see if a mail message is worth spending
more time looking at.
.TP
.B Feedback
tkbiff executes arbitrary actions upon reception of mail.  By default,
the actions are sounds \- typically dependent upon the sender but
configurable to other parts of the message, time of day, quantity
received, etc.  This type of feedback is not a frill.  Sound is a very
fast way of finding out who mail is from or what it's about without
having to shuffle windows or look at the screen in the first place.
Of course, you can turn off the sound if you want \- either
temporarily or permanently.
.TP
.B Minimal screen real-estate
tkbiff avoids unnecessary frills such as blinking stamps or borders
inside of borders inside of borders.  All you see is your mail and in
a very clear, obvious, and accessible way.  Of course, if you really
want glorious 3d highlights, huge fonts, animations, etc., tkbiff can
provide that too.
.PP
tkbiff is actually a framework for building flexible mail notification
tools.  It does the basics such as tracking your incoming mail.  But
how tkbiff announces or displays mail is up to you.  Naturally, tkbiff
provides a pleasant default configuration \- described in more detail
below.
.SH ARGUMENTS
tkbiff understands many of the traditional X flags such as \-display
and \-geometry.  See wish(1) for a comprehensive list.  The remainder
of this section describes arguments specific to tkbiff.
.TP
.B \-m
By default, tkbiff attempts to locate and monitor your mail spool
file.  Override this default by calling tkbiff with the \-m flag and
the name of the mail spool file.  As a consequence of this, it is
trivial to monitor multiple mail folders simply by running multiple
copies of tkbiff.
.TP
.B \-cf
By default, tkbiff uses the configuration file ~/.tkbiff (or
$DOTDIR/.tkbiff if DOTDIR is defined).  Override this default by
calling tkbiff with the \-cf flag and the name of the configuration
file.
.TP
.B \-user
By default, tkbiff monitors the mail spool file of the current user
(or the mail file named by the \-m flag).  Calling tkbiff with the
\-user flag and a user name causes tkbiff to monitor the mail file of
the given user.
.SH TKBIFF MINIMAL CONFIGURATION
When you run tkbiff for the first time, it creates the file ~/.tkbiff
configured to provide a default behavior.  Configuration is performed
by editing the .tkbiff file.  (Due to the limited language permitted
by xrdb(1), the .Xdefaults file is not particularly useful for
configuring tkbiff.)  The .tkbiff file is written in Tcl, but most
changes are trivial and do not require extensive knowledge of Tcl.
.PP
Many people will be happy with most of the behavior of the default
GUI.  What most people want to change are the actions triggered by
mail arrival such as which sound is played and for whom.  This section
explains how to do that.
.SH ACTIONS
This section describes the default actions.
.PP
.B Announcements
.PP
The announce_new_msg procedure defines an action to call upon arrival
of a new message.  It prints the string "you have new mail from ..."
and plays a sound clip.
.PP
Change the action by editing the announce_new_msg procedure.  For
example, to suppress the "you have new mail" output, simply remove or
comment out the line at the beginning of the procedure that produces
the output.
.PP
Sound clips are controlled by matching against a part of the message
(usually the sender) and calling "play" upon a match.  The play
procedure takes a sound clip name and an optional argument of a volume
from 1 to 100.  The default is 50.  If the clip name doesn't have a
leading directory, tkbiff searches from several default directories
(including ~/sounds).  You can override this by defining the
environment variable SOUNDPATH to be a space-delimited list of
directories of sound files.
.PP
By default, the play command calls the UNIX play command.  Change this
by editing the "set localplaycmd ..." line.  Typical command-line
sound players (such as rplay) are trivially accomodated.  The variable
remoteplaycmd exists for playing commands remotely.  This is useful
when you are running tkbiff remotely but displaying it locally.  In
this situation, tkbiff automatically executes an rsh back to the local
host so that the sounds can be heard at the same host where the
display is.  (Of course, your .rhosts file must be configured to
permit rsh to be used without a password.)
.PP
Message do not have to be announced.  This can be done by removing any
action after matching them.  Similarly, it is possible to suppress
particular messages from displaying on the screen.  This is done by
adding similar match-and-execute code in the command prep_new_msg.
(This automatically suppresses announcements as well.)  See the
default .tkbiff for examples.
.SH USING THE GUI
All of the tkbiff defaults can be easily changed.  This section
describes most of the default behavior.  (Some things are provided but
don't really need to be said \- such as how scrollbars work or that
buttons appear depressed when you push on them.  Yes, even these
things can be changed if you really want.)
.TP
.B Viewing messages
.PP
When unread mail exists, tkbiff displays a list of senders and
subjects.  This is the \fImain\fR window.  Clicking on a message in
the main window with the left mouse button brings up the body of the
message in another window.  Clicking on the same message in the main
window makes the message window go away.
.PP
Hereafter, the left, middle, and right mouse buttons will be indicated
as <1>, <2>, and <3>.  Other keys will be indicated using the X keysym
name \- i.e., <space> refers to the space key.
.PP
If the message is long enough, a scrollbar is provided.  Scrolling is
also possible using some of the more(1) conventions \- i.e., <space>
pages forward while <delete> and <backspace> page backwards.
.PP
<1> is useful if you want to read the message.  Sometimes you are
pretty sure the message can be ignored but you just want to take a
quick peek.  Do this by clicking on the main window with <2> which
brings up a message window only as long as <2> is held down.
.PP
<1> and <2> display the sender in the title bar and the subject and
body in the message window itself.  Holding down the shift key while
pressing <1> or <2> causes the window to include To:, Cc:,
Resent-from: and Date:.  Usually these are of little value, but
occasionally they are significant.  For example, To: and Cc: allow you
to quickly see if a message was sent to you personally or via a list.
.PP
<3> removes a message from the display.  This is useful when you can
forget about the message until such time as you read it with your
regular mail reader.  With no messages displayed, <3> iconifies the
main window.  If your window manager can iconify by unmapping
(IconifyByUnmapping in twm), this allows the window to disappear
entirely.  The main window is automatically deiconified when mail
arrives.
.PP
Inside the message window, <1> selects text and copies it to the X
clipboard, in the same style as xterm(1).
.PP
Besides using <1> or <2>, message windows can be removed from the
display by using the window manager's delete operation (f.delete in
twm).  This is convenient if you have bound the delete operation to a
keystroke.
.TP
.B Controlling the sound
.PP
Sound generation is on by default.  <s> toggles the sound off and on.
(I find it pleasant to temporarily disable the sound while I'm on
conference calls - that way, when things get boring, I can still learn
about and browse new mail without anyone else knowing.)
.TP
.B Fonts
.PP
The font for the main window is 5x8, a very, very small font.  Change
this permanently by editing the value for main_font and restarting
tkbiff.  It is occasionally useful to just increase the font
temporarily \- such as when demoing tkbiff to several people crowded
around the monitor.  <f> toggles between the default font and an
alternate (much bigger) font.  Edit main_font_alt to change the
alternate font permanently.
.PP
In contrast to the tiny font used by the main window, other tkbiff
windows use more traditionally-sized fonts.  Change these by editing
the .tkbiff file.
.PP
The fonts used by the main window and message windows should be
fixed-width.  (tkbiff doesn't care itself, but most mail messages look
\fIfunny\fR with variable-width fonts.)
.TP
.B Help
.PP
Both <?> and <h> raise and lower a help window containing a brief
description of how to use tkbiff.  Attributes that would otherwise be
hard to know (such as the settings of the toggles) are also reported
in the help window.  The help window is dynamically updated to reflect
changing attributes, even if the window is displayed.
.SH "THE GUI \- ESOTERIC BEHAVIOR"
This section describes some esoteric features of tkbiff's default GUI.
.TP
.B Monitoring mail that has been read
.PP
By default, tkbiff displays and announces only \fInew\fR mail.  tkbiff
also classifies mail as \fIunread\fR and \fIold\fR mail.  unread means
the mail has been read into a mail reader but not actually displayed
to the user.  (These distinctions are necessary because some users
read their mail and then save it back to their spool file.  At the
same time, it is also useful to be able to run tkbiff on mail archives
and show all of the existing mail.)
.PP
The settings may be permanently changed by editing the .tkbiff file.
The settings may be temporarily changed by pressing any of several
keys, while in any tkbiff window.
.TP
.B u
toggles display of unread messages.  Suppressed by default.
.TP
.B r
toggles display of read messages.  Suppressed by default.
.TP
.B n
toggles display of new messages.  Displayed by default.
.TP
.B Controlling the main window
.PP
By default, the main window is kept small.  If more than five message
arrive, a scrollbar is added.  This maximum size can be changed by
resizing the window.  If the window is resized larger than needed, it
shrinks back to the minimum size needed, but the resize request is
remembered as a maximum window size.  The size may be changed
permanently by editing the .tkbiff file.
.PP
\fIAutoscroll\fR means that if the scrollbar is present and the last
message is visible, the main window will automatically scroll so that
new messages become visible.  By default, autoscroll is on.
Autoscroll can be toggled on and off with <a> in any window.
Autoscroll can be permanently changed by editing the .tkbiff file.
.PP
\fIAutodeiconify\fR means that the main window is deiconified when new
mail arrives.  By default, autodeiconify is on.  Autodeiconify can be
toggled on and off with <i> in any window.  Autodeiconify can be
permanently changed by editing the .tkbiff file.
.PP
\fIAutoraise\fR means that the main window is raised above any others
when new mail arrives.  By default, autoraise is on.  Autoraise can be
toggled on and off with <t> in any window.  Autoraise can be
permanently changed by editing the .tkbiff file.
.SH "THE DEFAULT .TKBIFF FILE \- FURTHER CONFIGURATION"
.PP
There is no GUI code in the tkbiff executable itself.  The GUI is
entirely specified by the ~/.tkbiff file.  This section provides
advice for editing the .tkbiff file.
.PP
The configuration file is reread before each check for new mail.
Thus, changes to the sender-to-sound associations will automatically
be picked up.  There is no need to restart tkbiff.  (This is done
partly as a convenience but also simply because it can be done \- it
takes very little time to reread the configuration file.)
.PP
By default, tkbiff checks for new mail every four seconds.  The check
takes very little time, so there is little point in making the check
less often.  Nonetheless, <return> forces tkbiff to check immediately.
This is useful if you're testing configurations and you don't want to
wait at all before the configuration file is reread and mail checked.
.PP
The beginning of the .tkbiff files contains the configurations that
most people will want to change, namely whether messages should
trigger sounds or not and which sounds should be played.  Next in the
configuration file is the init procedure which establishes initial
defaults, such as the initial size of the main window, whether it
should autoscroll, etc.  Because these items are initial defaults,
they are not reevaluated when the configuration file is reread.
.PP
To make things simpler for the user who wants to see just the easy
things to reconfigure, the init procedure also lists the defaults that
users are most likely to want to change.  This includes border widths,
highlight widths, colors, and key bindings.
.PP
Following the init procedure is the play procedure.  The play
procedure searches for the requested sound file, massages the name
appropriately (such as by appending .au), and several other things.
Adapting tkbiff to different sound players can be done here.  When
running tkbiff in a sufficiently heterogenous environment, it may make
more sense to create an external program for each platform that
follows the default API that tkbiff expects for a sound player.  See
the .tkbiff file for more details.
.SH "FOR SYSTEM ADMINISTRATORS \- EDITING TKBIFF ITSELF"
.PP
If you are installing tkbiff for your site, it is useful to set up
system-wide defaults.  Assuming you just want to make small
modifications to the default .tkbiff file, do that as follows:
.PP
1) Run tkbiff.  Let it create a .tkbiff file.
.PP
2) Edit .tkbiff, and verify it works.
.PP
3) Edit tkbiff.  Delete everything after "DO NOT CHANGE THIS LINE".
Then insert your new .tkbiff file and save tkbiff.  New users will get
the new .tkbiff file.
.PP
Likely things to edit are all in the init procedure.  They include:
.TP
.B Default fonts
Some fonts work spectacularly badly.  If fonts
look awful, choose different ones.
.TP
.B Default list of directories of sounds
This is stored in the variable "sounddirs".
.TP
.B Default sound player and volume
These are stored in "localplaycmd" and "default_volume".  See the
instructions in .tkbiff for more information.
.SH "THE TKBIFF API"
.PP
This section describes tkbiff's interface.  If you want to construct
an entirely different GUI, this is the interface to use.  In fact, you
don't even need a GUI interface.  With the appropriate configuration
file, tkbiff can run as a background agent, perhaps communicating with
another program such as a database or a browser or yet other agents.
.TP
.SH Writable variables
.TP
.B mbox
name of mail box or folder being monitored
.TP
.B rcfile
name of configuration file
.TP
.B sleep
number of seconds to sleep before each check
.TP
.SH Read-only variables
.TP
.B tkbiff_version
version string of tkbiff
.TP
.B all_ids
array of all message ids in use.  Element names are the message ids.  Value is an integer defining the nth check upon which the message was last found.
.TP
.B all_list
list of all message ids in use
.TP
.B new_list
list of the new message ids read this cycle
.TP
.B recently_seen_ids
array of message ids recently seen but not currently in use.  Element
names are the message ids.  Values are integers defining the nth check
upon which messages were last found.  This array allows the GUI to
remember (and not reannounce) mail that is temporarily gone which
occurs due to other mail software temporarily truncating a mail file
and then restoring it.
.TP
.B msg
array of message ids.  Element names are of the form "id,type" where
id is a message id and type is one of from, sender, to, cc, subject,
replyto, date, or body and describing the value of the array element.
.TP
.SH Procedures
.TP
.B announce_new_msgs
called when the variable new_list is non-empty.
.TP
.B renounce_msgs ids
called when messages have disappeared (presumably because the user
read them).  The argument is a list containing the ids.  The
message-specific data in the msg array is valid until this procedure
returns.
.TP
.B short_from
called to select the more pleasant parts of the From: field for
display purposes.
.TP
.B busy
called whenever tkbiff is about to start doing something
time-consuming.  This is typically used for changing the shape of the
cursor.
.TP
.B idle
called when tkbiff is about to stop doing something
time-consuming.  This is typically used for changing the shape of the
cursor.
.TP
.B usage
called when tkbiff is invoked with incorrect arguments.
.SH BUGS
.TP
.B Misconfigured NFS mounts
Mailboxes should not be stored on partitions with NFS-caching enabled.
tkbiff can not detect new mail in such mailboxes until the cache is
flushed.  tkbiff will work on such misconfigured hosts if the variable
suppress_nfs_caching exists.
.SH SEE ALSO
.BR Tcl (l)
.SH AUTHOR
Don Libes, National Institute of Standards and Technology
.SH ACKNOWLEDGMENTS
Thanks to John Ousterhout for Tcl and Tk.
.PP
Design and implementation of
.B tkbiff
was paid for in part by the U.S. government and is therefore in the public
domain.
However the author and NIST would like credit
if this program and documentation or portions of them are used.
